/*
 * Test program for gethostbyaddr() ala what Amanda calls.  Just looking
 * at /etc/hosts and doing nslookup calls may not match how the system
 * is actually configured to work (which to do first, NIS, etc).
 */

#include <stdio.h>
#include <sys/socket.h>
#include <netdb.h>
#include <arpa/inet.h>

int
main (argc, argv)
	int			argc;
	char			**argv;
{
	char			*addr;
	union {
		in_addr_t		ip;
		struct in_addr		in_addr;
	} u;
	struct hostent		*hp;
	int			l;
	char			*alias;
	char			**aliases;
	char			*address;
	char			**addresses;

	while (--argc > 0) {
		addr = *++argv;
		u.ip = inet_addr(addr);
		hp = gethostbyaddr((void *)&u.in_addr,
				   sizeof(u.in_addr),
				   AF_INET);
		if (! hp) {
			printf("addr %s -> error %d\n",
			       inet_ntoa(u.in_addr),
			       h_errno);
			continue;
		}
		printf("addr %s -> %s\n", inet_ntoa(u.in_addr), hp->h_name);
		l = 4 + 1 + strlen(inet_ntoa(u.in_addr)) + 3;
		for (aliases = hp->h_aliases;
		     (alias = *aliases) != NULL;
		     aliases++) {
			printf("%*.*s %s (alias)\n",
			       l, l, "",
			       alias);
		}
		for (addresses = hp->h_addr_list;
		     (address = *addresses) != NULL;
		     addresses++) {
			memcpy(&u.in_addr, address, sizeof(u.in_addr));
			printf("%*.*s %s (addr)\n",
			       l, l, "",
			       inet_ntoa(u.in_addr));
		}
	}
	return 0;
}
