/*
 * Test program for gethostbyname() ala what Amanda calls.  Just looking
 * at /etc/hosts and doing nslookup calls may not match how the system
 * is actually configured to work (which to do first, NIS, etc).
 */

#include <stdio.h>
#include <sys/socket.h>
#include <netdb.h>
#include <arpa/inet.h>

int
main (argc, argv)
	int			argc;
	char			**argv;
{
	char			*name;
	struct in_addr		in_addr;
	struct hostent		*hp;
	int			l;
	char			*alias;
	char			**aliases;
	char			*address;
	char			**addresses;

	while (--argc > 0) {
		name = *++argv;
		hp = gethostbyname(name);
		if (! hp) {
			printf("name %s -> error %d\n", name, h_errno);
			continue;
		}
		printf("name %s -> %s\n", name, hp->h_name);
		l = 4 + 1 + strlen(name) + 3;
		for (aliases = hp->h_aliases;
		     (alias = *aliases) != NULL;
		     aliases++) {
			printf("%*.*s %s (alias)\n",
			       l, l, "",
			       alias);
		}
		for (addresses = hp->h_addr_list;
		     (address = *addresses) != NULL;
		     addresses++) {
			memcpy(&in_addr, address, sizeof(in_addr));
			printf("%*.*s %s (addr)\n",
			       l, l, "",
			       inet_ntoa(in_addr));
		}
	}
	return 0;
}
